# This file is part of the graph-includes package
#
# (c) 2005 Yann Dirson <ydirson@altern.org>
# Distributed under version 2 of the GNU GPL.

package graphincludes::extractor::C;
use strict;
use warnings;

use graphincludes::params;
use File::Basename qw(dirname);

sub getdeps {
  my $self = shift;
  my %deps;

  while (<>) {
    my $dstfile;
    if (m/^\s*#\s*include\s*"(.*)"/) {
      $dstfile = $self->locatefile ($1, dirname($ARGV), @graphincludes::params::inclpath);
    } elsif (m/^\s*#\s*include\s*<(.*)>/) {
      $dstfile = $self->locatefile ($1, @graphincludes::params::inclpath);
    } else {
      next;
    }

    $self->record_dep (\%deps, $ARGV, $dstfile);
  }
  return \%deps;
}

1;
